#ifndef _LINUX_TYPES_H
#define _LINUX_TYPES_H

#include <stdlib.h>
#include <stdint.h>

#define BITS_PER_LONG 64

typedef uint8_t u8, __u8;
typedef int8_t s8, __s8;
typedef uint16_t u16, __u16, __le16, __be16;
typedef int16_t s16, __s16;
typedef uint32_t u32, __u32, __le32, __be32;
typedef int32_t s32, __s32;
typedef uint64_t u64, __u64, __le64, __be64;
typedef int64_t s64, __s64;

typedef struct {
        __u32 u[4];
} __attribute((aligned(16))) __vector128;

struct module {
	int	gpgsig_ok;
};

#define prefetch(X) 0

#define __init /**/
#define __initdata /**/
#define __attribute_const__ __attribute__((const))
#define __force /**/
#define smp_wmb() do {} while(0)

static __inline__ int generic_fls(int x)
{
        int r = 32;

        if (!x)
                return 0;
        if (!(x & 0xffff0000u)) {
                x <<= 16;
                r -= 16;
        }
        if (!(x & 0xff000000u)) {
                x <<= 8;
                r -= 8;
        }
        if (!(x & 0xf0000000u)) {
                x <<= 4;
                r -= 4;
        }
        if (!(x & 0xc0000000u)) {
                x <<= 2;
                r -= 2;
        }
        if (!(x & 0x80000000u)) {
                x <<= 1;
                r -= 1;
        }
        return r;
}

#define fls(x) generic_fls(x)

#endif
